package com.ktg.iscs.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ktg.common.core.text.Convert;
import com.ktg.common.utils.DateUtils;
import com.ktg.common.utils.StringUtils;
import com.ktg.iscs.domain.IsLock;
import com.ktg.iscs.domain.vo.lock.IsLockVO;
import com.ktg.iscs.mapper.IsLockMapper;
import com.ktg.iscs.service.IIsLockService;
import com.ktg.system.strategy.AutoCodeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 挂锁Service业务层处理
 *
 * @author cgj
 * @date 2024-11-19
 */
@Service
public class IsLockServiceImpl extends ServiceImpl<IsLockMapper, IsLock> implements IIsLockService
{
    @Autowired
    private IsLockMapper isLockMapper;
    @Autowired
    private AutoCodeUtil autoCodeUtil;

    /**
     * 查询挂锁
     *
     * @param lockId 挂锁主键
     * @return 挂锁
     */
    @Override
    public IsLock selectIsLockByLockId(Long lockId)
    {
        return isLockMapper.selectIsLockByLockId(lockId);
    }

    /**
     * 查询挂锁
     *
     * @param nfc 挂锁NFC
     *
     * @return 挂锁
     */
    @Override
    public IsLock selectIsLockByNfc(String nfc) {
        return isLockMapper.selectIsLockByNfc(nfc);
    }

    /**
     * 查询挂锁列表
     *
     * @param isLock 挂锁
     * @return 挂锁
     */
    @Override
    public List<IsLock> selectIsLockList(IsLock isLock)
    {
        return isLockMapper.selectIsLockList(isLock);
    }

    /**
     * 新增挂锁
     *
     * @param isLock 挂锁
     * @return 结果
     */
    @Override
    public int insertIsLock(IsLock isLock)
    {
        // 1.检查挂锁名称是否重复
        List<IsLock> lockList = list(Wrappers.<IsLock>lambdaQuery().eq(IsLock::getLockName, isLock.getLockName()));
        Assert.isFalse(!lockList.isEmpty(), "该挂锁名称已被使用!");
        // 2.检查挂锁编码是否重复
        List<IsLock> locks = list(Wrappers.<IsLock>lambdaQuery().eq(IsLock::getLockCode, isLock.getLockCode()));
        Assert.isFalse(!locks.isEmpty(), "该挂锁编码已被使用!");
        isLock.setCreateTime(DateUtils.getNowDate());
        return isLockMapper.insertIsLock(isLock);
    }

    /**
     * 修改挂锁
     *
     * @param isLock 挂锁
     * @return 结果
     */
    @Override
    public int updateIsLock(IsLock isLock)
    {
        // 1.检查挂锁名称是否重复
        List<IsLock> lockList = list(Wrappers.<IsLock>lambdaQuery()
                .eq(IsLock::getLockName, isLock.getLockName())
                .ne(IsLock::getLockId, isLock.getLockId()));
        Assert.isFalse(!lockList.isEmpty(), "该挂锁名称已被使用!");
        // 2.检查挂锁编码是否重复
        List<IsLock> locks = list(Wrappers.<IsLock>lambdaQuery()
                .eq(IsLock::getLockCode, isLock.getLockCode())
                .ne(IsLock::getLockId, isLock.getLockId()));
        Assert.isFalse(!locks.isEmpty(), "该挂锁编码已被使用!");
        isLock.setUpdateTime(DateUtils.getNowDate());
        return isLockMapper.updateIsLock(isLock);
    }

    /**
     * 批量删除挂锁
     *
     * @param lockIds 需要删除的挂锁主键
     * @return 结果
     */
    @Override
    public int deleteIsLockByLockIds(String lockIds)
    {
        Assert.notBlank(lockIds, "请选择需要删除的数据!");
        Long[] longIds = Convert.toLongArray(lockIds);
        return isLockMapper.deleteIsLockByLockIds(longIds);
    }

    /**
     * 删除挂锁信息
     *
     * @param lockId 挂锁主键
     * @return 结果
     */
    @Override
    public int deleteIsLockByLockId(Long lockId)
    {
        return isLockMapper.deleteIsLockByLockId(lockId);
    }

    @Override
    public Page<IsLockVO> getIsLockPage(Page<IsLock> page, IsLock isLock) {
        return isLockMapper.getIsLockPage(page, isLock);
    }

    @Override
    public Boolean insertIsLockByCabinet(IsLock isLock) {
        Assert.isFalse(StringUtils.isBlank(isLock.getLockNfc()), "请给我挂锁的nfc！");
        // 0.检查挂锁的nfc是否存在，存在就不允许添加
        List<IsLock> list = list(Wrappers.<IsLock>lambdaQuery()
                .eq(IsLock::getLockNfc, isLock.getLockNfc()));
        Assert.isTrue(list.isEmpty(), "该nfc的挂锁已存在！");
        // 1.自动生成名称
        String lockName = "挂锁-" + isLock.getLockNfc();
        // 2.自动生成编码
        String lockCode = autoCodeUtil.genSerialCode("LOCK_CODE", null);
        isLock.setLockName(lockName);
        isLock.setLockCode(lockCode);
        isLock.setCreateTime(DateUtils.getNowDate());
        return save(isLock);
    }

}
